<?php
/*
Plugin Name: XmasB Quotes
Plugin URI: http://xmasb.com/xmasbquotes
Description: Add quotes with images to your wordpress blog
Version: 0.4
Author: XmasB
Author URI: http://xmasb.com
*/

/*  Copyright YEAR  PLUGIN_AUTHOR_NAME  (email : PLUGIN AUTHOR EMAIL)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('XMASB_QUOTES_TABLE', $table_prefix . 'xmasb_quotes');

function xmasb_quotes_install ()
{
	global $wpdb;

	$xmasb_quotes_db_version = "0.4";
	if($wpdb->get_var("SHOW TABLES LIKE '" . XMASB_QUOTES_TABLE . "'") != XMASB_QUOTES_TABLE)
	{
		$sql = "CREATE TABLE " . XMASB_QUOTES_TABLE . " (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			author tinytext NOT NULL default '',
			quote text NOT NULL,
			imgsrc tinytext NOT NULL default '',
			visible boolean NOT NULL default 1,
			UNIQUE KEY id (id)
			);";

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);

		$author = "Bob Dole";
		$quote = "The internet is a great way to get on the net.";

		$insert = "INSERT INTO " . XMASB_QUOTES_TABLE . " (author, quote) VALUES "
			. "('Bart', 'Remember, you can always find East by staring directly at the sun.'), "
			. "('Homer', 'Kids, you tried your best and you failed miserably. The lesson is, never try.'), "
			. "('Burns', 'A lifetime of working with nuclear power has left me with a healthy green glow... and left me as impotent as a Nevada boxing commissioner.'), "
			. "('Lisa', 'Solitude never hurt anyone. Emily Dickinson lived alone, and she wrote some of the most beautiful poetry the world has ever known... then went crazy as a loon.'), "
			. "('Marge', 'You should listen to your heart, and not the voices in your head.'), "
			. "('Moe', 'Call this an unfair generalization if you must, but old people are no good at everything.'), "
			. "(Ralph', 'Your toys are fun to touch. Mine are all sticky.')";

		$results = $wpdb->query( $insert );
		add_option("xmasb_quotes_db_version", $xmasb_quotes_db_version);
	}
	
	$installed_ver = get_option( "xmasb_quotes_db_version" );

	if( $installed_ver != $xmasb_quotes_db_version )
	{

		$sql = "CREATE TABLE " . XMASB_QUOTES_TABLE . " (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			author tinytext NOT NULL default '',
			quote text NOT NULL,
			imgsrc tinytext NOT NULL default '',
			visible boolean NOT NULL default 1,
			UNIQUE KEY id (id)
			);";

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);

		update_option( "xmasb_quotes_db_version", $xmasb_quotes_db_version );
	}	
}

function xmasb_random_quote ()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "xmasb_quotes";
	$sql = "SELECT * FROM " . XMASB_QUOTES_TABLE . " where visible=true ORDER BY RAND() limit 1";
	$quotes = $wpdb->get_results($sql);
	
	if ( !empty($quotes) )
	{
		xmasb_print_quote($quotes[0], true);
	}
	else
	{
		echo "<!-- XmasB_quotes: No quotes returned from query -->";
	}
}

function xmasb_print_quote ($quote, $showimage = false)
{
	if (is_user_logged_in())
	{
		?>
		<form action="" method="post">
		<?php
	}
	if ( $showimage )
	{
		$siteurl = get_option("siteurl");
		if ($siteurl[strlen($siteurl)-1] != "/") $siteurl .= "/";
		$quoteimg = 'wp-content/plugins/xmasb_quotes/images/' . $quote->author . '.gif';
		if (file_exists($quoteimg))
		{
		?>
			<span class="xmasb_quote_image">
				<img src='<?php echo $siteurl . $quoteimg; ?>' alt='$quote->author' />
			</span>
		<?php
		}
		else
		{
			?><!-- XmasB Quotes: "<?php echo $quoteimg; ?>" not found. --><?php
		}
	}
	else
	{
		?><!-- ShowImage turned off. --><?php
	}
	if ( $quote->visible )
	{
	?>
		<div class="xmasb_quote"><q><?php echo $quote->quote; ?></q></div>
	<?php
	}
	else
	{
	?>
		<div class="xmasb_quote_not_visible"><q><?php echo $quote->quote; ?></q></div>
	<?php
	}

	if ( !empty($quote->author) )
	{
		?>
		<div class="xmasb_quote_author"><strong><?php echo $quote->author; ?></strong></div>
		<?php
	}
	if (is_plugin_page())
	{
		?>
		<form action="" method="post">
		<input type="hidden" name="mode" value="edit">
		<input type="hidden" value="<?php echo $quote->id; ?>" name="quoteID"/>
		<input class="button" type="submit" value="<?php _e('Edit')?>" name="Submit"/>
		<input class="button" type="submit" onclick="return delete_confirmation_xmasb_quotes()" value="delete" name="mode"/>
		</form>
		<?php
	}
}

function xmasb_quotes_management_page()
{
	global $wpdb;
	$data = false;

	$mode = !empty($_REQUEST['mode']) ? $_REQUEST['mode'] : '';
	$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';
	
	if (empty($quoteID))
	{
		$quoteID = false;
	}
	
	/** Det skal vre mode for: add, edit, delete og list. */
	if ( empty($mode) )
	{
		$mode = 'new';
	}
	if ($mode == 'add')
	{
		$quote = !empty($_REQUEST['quote_quote']) ? $_REQUEST['quote_quote'] : '';
		$author = !empty($_REQUEST['quote_author']) ? $_REQUEST['quote_author'] : '';
		$visible = !empty($_REQUEST['quote_visible']) ? $_REQUEST['quote_visible'] : '';
		
		if ( ini_get('magic_quotes_gpc') )
		{
			$quote = stripslashes($quote);
			$author = stripslashes($author);
		}	
		
		$sql = "insert into " . XMASB_QUOTES_TABLE . " set quote='" . mysql_real_escape_string($quote)
	     . "', author='" . mysql_real_escape_string($author) . "', visible='" . mysql_real_escape_string($visible) . "'";
		$sqlresponse = $wpdb->query($sql);
		if ( $sqlresponse == 1 )
		{
			$sql = "select id from " . XMASB_QUOTES_TABLE . " where quote='" . mysql_real_escape_string($quote) . "'"
		     . " and author='" . mysql_real_escape_string($author) . "' and visible='" . mysql_real_escape_string($visible) . "' limit 1";
			$quotes = $wpdb->get_results($sql);
			if ( empty($quotes) || empty($quotes[0]->id) )
			{
				?>
						<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>That didn't go too well, and I really don't know why...</strong></p></div>
				<?php
			}
			else
			{
				?>
						<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Quote has been added with id <?php echo $quotes[0]->id?>.</strong></p></div>
				<?php
				$quote = false;
			}
		}
		else if ( $sqlresponse > 1 )
		{
		?>
				<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>All hell is lose. <?php echo $sqlresponse?> quotes added!</strong></p></div>
		<?php
		}
	}
	else if ( $mode == 'list' )
	{
		$sql = "SELECT COUNT(*) AS count FROM " . XMASB_QUOTES_TABLE;
		$numberofquotes = $wpdb->get_results($sql);
		$sql = "SELECT * FROM " . XMASB_QUOTES_TABLE . " order by id";
		$quotes = $wpdb->get_results($sql);
		if ( empty($quotes))
		{
			echo "No quotes found!";
			$mode = "new";
		}
		else
		{
			?>
			<div class="wrap">
			<h2>XmasB Quotes</h2>
			<div class="xmasb_quotes_block"><ul class="xmasb_quotes_list">
			<legend>Number of quotes: <?php echo $numberofquotes[0]->count ?></legend>
			<form name="quotelist" id="quotelist" method="post" action="">
				<input type="hidden" name="mode" value="new">
				<input class="button" type="submit" value="<?php _e('Add new') ?>" name="Submit"/>
			</form>
			<br />
		<?php
			foreach ($quotes as $quote)
			{
				echo "<li>";
				xmasb_print_quote($quote);
				echo "</li>";
			}
			?></ul></div><?php
		}
	}
	else if ( $mode == 'edit' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';	
	}
	else if ( $mode == 'edited' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';	
		$quote = !empty($_REQUEST['quote_quote']) ? $_REQUEST['quote_quote'] : '';
		$author = !empty($_REQUEST['quote_author']) ? $_REQUEST['quote_author'] : '';
		$visible = !empty($_REQUEST['quote_visible']) ? $_REQUEST['quote_visible'] : '';
		$sql = "update " . XMASB_QUOTES_TABLE . " set quote='" . mysql_real_escape_string($quote)
		     . "', author='" . mysql_real_escape_string($author) . "', visible='" . mysql_real_escape_string($visible) . "'"
		     . " where id='" . mysql_real_escape_string($quoteID) . "'";
		$sqlresponse = $wpdb->query($sql);
		if ( $sqlresponse == 1 )
		{
		?>
				<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Quote has been edited.</strong></p></div>
		<?php
			$quoteID = false;
		}
		else
		{
		?>
			<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Could not edit quote.</strong></p></div>
		<?php
		}
	}
	else if ( $mode == 'delete' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';
		if ( empty($quoteID) )
		{
			?>
			<div class="error"><p><strong>Failure:</strong> No quote ID given.</p></div>
			<?php			
		}
		else
		{
			$sql = "delete from " . XMASB_QUOTES_TABLE . " where id='" . mysql_escape_string($quoteID) . "'";
			$sqlresponse = $wpdb->query($sql);

			if ( $sqlresponse == 1 )
			{
				?>
				<div class="updated"><p>Quote <?php echo $quoteID;?> deleted successfully</p></div>
				<?php
			}
			else
			{
				?>
				<div class="error"><p><strong>Failure:</strong> Could not delete quote.</p></div>
				<?php
			}
		}
		$quoteID = false;
	}
	else if ( $mode == 'new' ) { }
	else{	echo "<p>Mode: " . $mode . "</p>"; }

	if ( $quoteID !== false )
	{
		if ( intval($quoteID) != $quoteID )
		{
		?>
		<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>WTH?!?</strong></p></div>
		<?php
			return;
		}
		else
		{
			$quote = $wpdb->get_results("select * from " . XMASB_QUOTES_TABLE . " where id='" . mysql_real_escape_string($quoteID) . "' limit 1");
			if ( empty($quote) )
			{
			?>
			<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>No quote found for id <?php echo $quoteID?></strong></p></div>
			<?php
				return;
			}
			$quote = $quote[0];
		}
	}
	if ( $mode != "list" )
	{
		?>
		<div class="wrap">
			<h2>XmasB Quotes</h2>
			<form name="quoteform" id="quoteform" class="wrap" method="post" action="">
				<?php wp_nonce_field('update-options') ?>
				<input type="hidden" name="mode" value="<?php echo $mode=="edit" ? "edited" : "add" ?>">
				<input type="hidden" value="<?php echo $quote->id; ?>" name="quoteID"/>
				<fieldset>
					<legend><?php _e('Quote'); ?></legend>
					<textarea name="quote_quote" class="input" cols=50 rows=7><?php if ( !empty($quote) ) echo htmlspecialchars($quote->quote); ?></textarea>
				</fieldset>
				<fieldset>
					<legend><?php _e('Author'); ?></legend>
					<input class="input" type="text" name="quote_author" value="<?php if ( !empty($quote) ) echo htmlspecialchars($quote->author); ?>" size="52" />
				</fieldset>
				<fieldset>
					<legend><?php _e('Visible'); ?></legend>
					<input type="radio" name="quote_visible" class="input" value="1" 
						<?php if ( empty($quote) || $quote->visible==1 ) echo "checked" ?>/> <?php _e('Yes'); ?>
						<br />
						<input type="radio" name="quote_visible" class="input" value="0" 
						<?php if ( !empty($quote) && $quote->visible==0 ) echo "checked" ?>/> <?php _e('No'); ?>
				</fieldset>
				<br />
				<input class="button bold" type="submit" value="<?php $mode=='edit' ? _e('Edit') : _e('Add') ?>" name="Submit" />
				<?php 
				if ( $mode == "edit" )
				{
					?><input class="button" type="submit" onclick="return delete_confirmation_xmasb_quotes()" value="delete" name="mode"/><?php
				}
				?>
			</form>
			<legend>Last 10 quotes added</legend>
			<?php
			$sql = "SELECT * FROM " . XMASB_QUOTES_TABLE . " order by id desc limit 10";
			$quotes = $wpdb->get_results($sql);
			if ( empty($quotes))
			{
				echo "No quotes found!";
			}
			else
			{
				?><div class="xmasb_quotes_block"><ul class="xmasb_quotes_list"><?php
				foreach ($quotes as $quote)
				{
					echo "<li>";
					xmasb_print_quote($quote);
					echo "</li>";
				}
				?></ul></div><?php
			}
			?>
			
			<form name="quotelist" id="quotelist" method="post" action="">
				<input type="hidden" name="mode" value="list">
				<input class="button" type="submit" value="<?php _e('Show list') ?>" name="Submit"/>
			</form>
		<?php
	}
	else
	{
	?>
		<form name="quotelist" id="quotelist" method="post" action="">
			<input type="hidden" name="mode" value="new">
			<input class="button" type="submit" value="<?php _e('Add new') ?>" name="Submit"/>
		</form>
	<?php
	}
	?>
		</div>
	<?php
}

# Include CSS/JS in the HEAD of the html page
function xmasb_quotes_head_inclusion() {
	$siteurl = get_option("siteurl");
	if ($siteurl[strlen($siteurl)-1] != "/") $siteurl .= "/";
	$plugin_path = $siteurl . "wp-content/plugins/" . dirname(plugin_basename(__FILE__)) . "/";
	
	# CSS inclusion
	echo "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"" . $plugin_path;
	echo (is_plugin_page() ? "admin_page" : basename(__FILE__, ".php")) . ".css" . "\" />\n";

	# JS inclusion
	echo "<script type=\"text/javascript\" src=\"" . $plugin_path . "xmasbquotes.js\"></script>\n";
}

/*
Widget code
*/

function widget_xmasb_quotes_init()
{
	if ( !function_exists('register_sidebar_widget') )
			return;

	function widget_xmasb_quotes($args)
	{
			extract($args);

			$options = get_option('widget_xmasb_quotes');
			$title = $options['title'];

			echo $before_widget . $before_title . $title . $after_title;

			if ( !function_exists('xmasb_random_quote') )
			{
					echo '<div class="wp-xmasb_quote-error">Cannot find the XmasB quotes plugin. If you have installed it check if you have activated it. If you have not installed it, you can download it from <a title="XmasB Quotes" href="http://xmasb.com">xmasb.com</a>.</div>';
			}
			else
			{
				xmasb_random_quote();
			}

			echo $after_widget;
	}

	function widget_xmasb_quotes_control()
	{
			$options = get_option('widget_xmasb_quotes');
	if ( !is_array($options) )
		$options = array('title'=>'XmasB Quotes');
	if ( $_POST['xmasb_quotes-submit'] )
	{

		$options['title'] = strip_tags(stripslashes($_POST['xmasb_quotes-title']));
		update_option('widget_xmasb_quotes', $options);
	}

	$title = htmlspecialchars($options['title'], ENT_QUOTES);
	
	echo '<p style="text-align:right;"><label for="xmasb_quotes-title">Title: <input style="width: 200px;" id="xmasb_quotes-title" name="xmasb_quotes-title" type="text" value="'.$title.'" /></label></p>';
	echo '<input type="hidden" id="xmasb_quotes-submit" name="xmasb_quotes-submit" value="1" />';
	}

	register_sidebar_widget('XmasB Quotes', 'widget_xmasb_quotes');
	register_widget_control('XmasB Quotes', 'widget_xmasb_quotes_control', 300, 100);
}


# Add 'XmasB Quotes' page to Wordpress' Manage menu
function xmasb_quotes_add_management_page() {
    if (function_exists('add_management_page')) {
		  add_management_page('XmasB Quotes', 'XmasB Quotes', 8, basename(__FILE__), 'xmasb_quotes_management_page');
    }
}

# Init Widget
add_action('plugins_loaded', 'widget_xmasb_quotes_init');

# CSS/JS inclusion in HEAD
add_action('wp_head', 'xmasb_quotes_head_inclusion');
add_action('admin_head', 'xmasb_quotes_head_inclusion');

add_action('activate_' . dirname(plugin_basename(__FILE__)) . '/' . basename(plugin_basename(__FILE__)), 'xmasb_quotes_install');
add_action('admin_menu', 'xmasb_quotes_add_management_page');
